var path = require('path')

var Backbone = require('backbone')

module.exports = Backbone.Router.extend({
  initialize: function(options) {
    var that = this
    
    this.server = false

    if (options.app) {
      this.server = true 
    }

    if (options.routes) {
      that.routes = options.routes
    } 
   
    // Add express routes 
    if (this.server) {
      for (route in that.routes) {
        if (typeof(that.routes[route]) === 'function') {
          continue
        }

        var fnName = that.routes[route]
        var fn = that.routes[fnName]
        options.app.get('/' + route, function(req, res) {
          fn(function(err, output) {
            if (err) {
              throw new Error(err.message)
            }
            res.end(output)  
          })
        }) 
      }
    }
      
    if (typeof(that.postInitialize) === 'function') {
      that.postInitialize(options)
    }
  },
})
