var async = require('async')
  , path = require('path')

var Backbone = require('backbone')
  , Handlebars = require('handlebars')

if (typeof(window) === 'undefined') {
  Backbone.$ = function() {
    return {
      attr: function() {}
    }
  }
}

module.exports = Backbone.View.extend({
  initialize: function() {
    var that = this
    that.server = false

    if (typeof(window) === 'undefined') {
      that.server = true
    }

    if (typeof(that.postInitialize) === 'function') {
      that.postInitialize(app, routes)
    }
  },
  render: function(callback) {
    var that = this

    if (that.server) {
      that.renderServer(callback)
    } else {
      that.renderClient(callback)
    }
  },
  renderClient: function(callback) {
   // that.$el.html(that.template(that.data)) 
  },
  renderServer: function(callback) {
    var fs = require('fs')
    var that = this;

    async.auto({
      template: function(subCallback) {
        fs.readFile(
          path.join(that.templatePath, that.template + '.handlebars'),
          'ascii',
          subCallback
        )
      },
      layout: ['template', function(subCallback, results) {
        if (that.layout != null) {
          fs.readFile(
            path.join(that.layoutPath, that.layout+ '.handlebars'),
            'ascii',
            subCallback
          )
        } else {
          subCallback(null, null)
        }
      }],
    },
    function(err, results) {
      if (err) {
        throw new Error(err.message)
        return callback(err)
      }

      var template = Handlebars.compile(results.template)

      if (results.layout === null) {
        return that.postRender(template(that.data), callback)
      } else {
        layout = Handlebars.compile(results.layout)
        return that.postRender(
          layout({ body: template(that.data) }),
          callback
        )
      }
    })
  },
  postRender: function(output, callback) {
    callback(null, output)
  }
})
